#!/bin/sh
# Enable CGIs on Apache web server

APP_NAME=netrexcamstreamer
APP_ROOT_DIR=/usr/local/packages/netrexcamstreamer
if [ -d /var/spool ] && [ ! -d /var/cgi-root ]; then
  CGI_DIR=/var/spool/cgi-root
else
  CGI_DIR=/var/cgi-root 
fi
. "$APP_ROOT_DIR/_paths.sh"
HTTPD_CONF=/etc/apache2/conf.d/${APP_NAME}.conf

if [ -e /etc/apache2/httpd.conf ]; then
    mkdir -p $CGI_DIR
    if [ `mount | grep -c "/usr/html/pwdroot"` -eq 0 ]; then
        cp -rf /usr/html/pwdroot/* $CGI_DIR/
        mount --bind $CGI_DIR /usr/html/pwdroot
    fi
    cp -rf $APP_ROOT_DIR/html/*.cgi $CGI_DIR/

    rm -f $HTTPD_CONF
    for CGI_FILE in `ls $APP_ROOT_DIR/html/*.cgi`; do
        echo "ScriptAlias /local/${APP_NAME}/`basename $CGI_FILE` /usr/html/pwdroot/`basename $CGI_FILE`" >> $HTTPD_CONF
        chown www:admin $CGI_DIR/`basename $CGI_FILE`
        chmod 750 $CGI_DIR/`basename $CGI_FILE`
    done
    cat >> $HTTPD_CONF << EOF
<Directory /usr/html/pwdroot>
    Options +ExecCGI +FollowSymLinks
    AddHandler cgi-script .cgi
</Directory>
EOF
    chmod 600 $HTTPD_CONF
    chown www:www $HTTPD_CONF
    /usr/sbin/httpd -k graceful

    #Allow apache upload to certain paths..
    mkdir -p "$PATH_USER_AUDIO_FLASH"
    chmod 770 "$PATH_USER_AUDIO_FLASH"
    chgrp admin "$PATH_USER_AUDIO_FLASH"
    mkdir -p "$PATH_DYNAMIC_OVERLAY"
    chmod 770 "$PATH_DYNAMIC_OVERLAY"
    chgrp admin "$PATH_DYNAMIC_OVERLAY"
    #Allow apache upload to SD_card..
    adduser wwwaov storage
    adduser wwwaovp storage
    adduser wwwao storage
    adduser wwwaop storage
    adduser wwwav storage
    adduser wwwavp storage
    adduser wwwap storage
    adduser wwwa storage
    adduser wwwov storage
    adduser wwwovp storage
    adduser wwwop storage
    adduser wwwo storage
else
    #Boa
    grep "AddType application/x-httpd-cgi cgi" $APP_ROOT_DIR/conf/cgi.txt
    if [ $? != 0 ]; then
        echo "AddType application/x-httpd-cgi cgi" >> $APP_ROOT_DIR/conf/cgi.txt
    fi

    grep "SinglePostLimit 83886080" $APP_ROOT_DIR/conf/cgi.txt
    if [ $? != 0 ]; then
        echo "SinglePostLimit 83886080" >> $APP_ROOT_DIR/conf/cgi.txt
    fi
    /etc/init.d/httpd force-reload
fi
